#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <vector>
#include <math.h>
#include "my_factor.h"
using namespace std;

typedef struct{
  float C, S;
} point;

const int len = 431500;

void mySC(double z, point *data) {
    if(z > 0.1)
    {
        data->C = (1.0 - cos(sqrt(z)))/z;
        data->S = (sqrt(z) - sin(sqrt(z)))/sqrt(z*z*z);
    }
    else if(z < -0.1)
    {
        data->C = (1.0 - cosh(sqrt(-z)))/z;
        data->S = (sinh(sqrt(-z)) - sqrt(-z))/sqrt(-z*z*z);
    }
    else
    {
        //long double z2, z3, z4, z5, z6, z7, z8, z9, z10, z11, z12;
        double z2, z3, z4, z5, z6, z7, z8, z9, z10, z11, z12;

        z2 = z*z;
        z3 = z*z2;
        z4 = z*z3;
        z5 = z*z4;
        z6 = z*z5;
        z7 = z*z6;
        z8 = z*z7;
        z9 = z*z8;
        z10 = z*z9;
        z11 = z*z10;
        z12 = z*z11;

        data->C = (double)(1.0/f2 - z/f4 + z2/f6 - z3/f8 + z4/f10 - z5/f12 + z6/f14 - z7/f16 + z8/f18 - z10/f20 + z11/f22 - z12/f24);
        data->S = (double)(1.0/f3 - z/f5 + z2/f7 - z3/f9 + z4/f11 - z5/f13 + z6/f15 - z7/f17 + z8/f19 - z10/f21 + z11/f23 - z12/f25);
    }
    return;
}

//globe len is where this stops
void readFile(string fn, double* src) {
  fstream file(fn, ios::in);
  string line, first;
  int max = 0;
  double z;
  getline(file, line);  // skip header line
  while(getline(file,line))
  {
    stringstream row(line);
    getline(row, first, ',');
    z = stod(first);
    src[max] = z;
    max = max + 1;
    if (max >= len) break;
  }
}

int main() {
  int max = len;
  double src[max];

  // NOTE: read from file
  //readFile("sc_output.csv", src);

  // NOTE: or just use fake data
  for(int i = 0; i < max; ++i) src[i] = i;

  int slow = len/10;
  point rr[max];
  // #pragma acc set device_num(2)
  // #pragma acc parallel loop present(src) copyin(src[0:max]) copyout(rr[0:max])
  #pragma acc parallel loop 
  for( int j = 0; j < slow; ++j ) {
    for( int i = 0; i < max; ++i ) {
      mySC(src[i], &rr[i]);
    }
  }

  //for( int i = 0; i < len; ++i ) cout << rr[i].x << " " << rr[i].y << " " << rr[i].z << endl;
  cout << rr[max-1].S << " " << rr[max-1].C << " " << endl;
}
